org 100h ; assume ah=0 cx=255 si=256 di=sp=-2 cs<=0x7e5d [-2]=0

;5d
  pop bp      ; bp=0
;8e 1c
  mov ds,[si] ; ds=0x8e5d for cosine table
  mov al,0x13

; Overlap: set mode 320x200
;cd
  db 0xcd     ; init: cd 10     int 10h
              ;       d0 2a     shr byte[bp+si],1
              ;       01 78 02  add [bx+si+2],di

; Accumulate color, convert to triangle, draw pixel
;10 d0
M:db 0x10,0xd0; adc al,dl (we need this variant)
;2a 01
  sub al,[bx+di]
;78 02
  js T

  not al      ; 0..255 -> 255..128,128..255
T shr ax,3    ; -> 31..16,16..31
  stosb

; Cosine table: harmonic oscillator
; init: cx=C=255, si=S=256
  mov [di],ch ; cos[adr] = C/256
  add cx,si   ; C += S
  mov ax,24
  imul cx
  sub si,dx   ; S -= C/3276.8

; Convert pixel address to X,Y
  xor dx,dx
  mov ax,di
  mov bx,320
  inc bp
  jnz D-1     ; jump to "idiv bx"
              ; bp=0 ax=di=T(0xd339, 0xd33b, ..., 0xd401, ...)
  hlt         ; 18.2 fps
  scasw       ; di+=2: next frame

;2e 88 67 f7  ; mov [cs:bx-9],ah
  mov [byte cs:bx-320+C+1],ah  ; modify every 128 frames

;fb           ; sti
D db 0xfb     ; f7 fb (idiv bx)
              ; dx = X(0..319) = adr % 320
              ; ax = Y(0..200) = adr / 320

; Plasma
  push 0xa000

  xlat
  cbw
X imul bx,ax,5
C add al,[bx+si] ;<- modified: [bx+si bx+di bp+si bp+di si di 0xdbf7 bx]
;f7 db
  neg bx         ;<- can be a part of the "add"
  xchg ax,dx
  jg X

  pop es  ; here to align "add al,[bx+si]" to [0x137]
  jmp M
